# +-----------------------------------------------------------------------+
# | pLoader - a Perl photo uploader for Piwigo                            |
# +-----------------------------------------------------------------------+
# | Copyright(C) 2008      Piwigo Team                  http://piwigo.org |
# +-----------------------------------------------------------------------+
# | This program is free software; you can redistribute it and/or modify  |
# | it under the terms of the GNU General Public License as published by  |
# | the Free Software Foundation                                          |
# |                                                                       |
# | This program is distributed in the hope that it will be useful, but   |
# | WITHOUT ANY WARRANTY; without even the implied warranty of            |
# | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
# | General Public License for more details.                              |
# |                                                                       |
# | You should have received a copy of the GNU General Public License     |
# | along with this program; if not, write to the Free Software           |
# | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
# | USA.                                                                  |
# +-----------------------------------------------------------------------+
package Uploader::GUI::wxHtmlWindow;

use strict;
use Wx::Html;
use base qw(Wx::Dialog);
use Wx qw/
             wxTheApp
             wxDefaultSize
             wxDefaultPosition
             wxALIGN_CENTER_VERTICAL
             wxALL
             wxVERTICAL
             wxLIST_AUTOSIZE
             wxDEFAULT_DIALOG_STYLE
             wxMAXIMIZE_BOX
             wxMINIMIZE_BOX
             wxRESIZE_BORDER
             wxSTAY_ON_TOP
             wxGROW
         /;

sub new {
    my ($class, $params) = @_;

    my $this = $class->SUPER::new(
        undef,
        -1,
        $params->{caption},
        wxDefaultPosition, 
        wxDefaultSize,
        wxDEFAULT_DIALOG_STYLE|
        wxMAXIMIZE_BOX|
        wxMINIMIZE_BOX|
        wxSTAY_ON_TOP|
        wxRESIZE_BORDER
    );
    $this->{sizev} = Wx::BoxSizer->new( wxVERTICAL );

    $this->{html} = Wx::HtmlWindow->new(
        $this,
        -1,
        wxDefaultPosition, 
        $params->{size},
    );


    $this->{html}->SetPage(
        $params->{html}
    );

    # layout
    $this->{sizev}->Add( $this->{html}, 1, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 2 );
    $this->SetSizer( $this->{sizev} );
    $this->{sizev}->SetSizeHints( $this );

    Wx::Event::EVT_HTML_LINK_CLICKED( $this, $this->{html}, \&OnHtmlLinkClicked);

  return $this;
}

sub InitHrefCallbacks {
    my ( $self, $callbacks ) = @_;
    
    $callbacks ||={};
    $self->{HrefCallbacks} = $callbacks ;	
}

sub OnHtmlLinkClicked {
    my ( $self, $event ) = @_;

    my $href = $event->GetLinkInfo->GetHref, "\n";

    $self->{HrefCallbacks}->{$href}->() if exists $self->{HrefCallbacks}->{$href};
}


1;

